unit cube3du1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Glide, Sst1vid, tlib, D3dfx;

type
  TRotationMode = (XAXIS, YAXIS, ZAXIS);
  TForm1 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    fFirstClick  : Boolean;
    fTimeToClose : Boolean;
    version     : array[0..79] of Char;
    hwconfig    : GrHwConfiguration;
    Verts: IntegerArray;
    vtx, vtx1: GrVertexArray;
    RotationMode: TRotationMode;
    procedure WMCaptureChanged(var msg : TMessage); message wm_capturechanged;
    procedure Main;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function Deg2Rad(X: Single): Single;
begin
  Result:=X*Pi/180;
end;

procedure RotateZ(Var dstVert: GrVertex;srcVert:GrVertex; Degres: Single);
Var C,S: Single;
begin
  C:=cos(Deg2Rad(Degres));
  S:=sin(Deg2Rad(Degres));
  dstVert.x:=c*srcVert.x-s*srcVert.y;
  dstVert.y:=s*srcVert.x+c*srcVert.y;
  dstVert.z:=srcVert.z;
end;

procedure RotateY(Var dstVert: GrVertex;srcVert:GrVertex; Degres: Single);
Var C,S: Single;
begin
  C:=cos(Deg2Rad(Degres));
  S:=sin(Deg2Rad(Degres));
  dstVert.x:=c*srcVert.x-s*srcVert.z;
  dstVert.z:=s*srcVert.x+c*srcVert.z;
  dstVert.y:=srcVert.y;
end;

procedure RotateX(Var dstVert: GrVertex;srcVert:GrVertex; Degres: Single);
Var C,S: Single;
begin
  C:=cos(Deg2Rad(Degres));
  S:=sin(Deg2Rad(Degres));
  dstVert.x:=srcVert.x;
  dstVert.y:=c*srcVert.y-s*srcVert.z;
  dstVert.z:=s*srcVert.y+c*srcVert.z;
end;

procedure TForm1.WMCaptureChanged(var msg : TMessage);
begin
  inherited;
  if not fFirstClick then
    fTimeToClose := true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fFirstClick := true;
  fTimeToClose := false;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if fFirstClick then
  begin
    fFirstClick := false;
    SetCapture(handle);
    Main;
  end
  else
    case Key of
      'r' : begin
              Inc(RotationMode);
              if ( RotationMode > ZAXIS ) then
                RotationMode := XAXIS;
            end;
      'q' : fTimeToClose := true;
      #27 : fTimeToClose := true;
    end;
end;

procedure TForm1.Main;
const
  resolution : GrScreenResolution_t = GR_RESOLUTION_640x480;
  scrWidth   : Single = 640.0;
  scrHeight  : Single = 480.0;
  distance   = 100;
var i: integer;
    angle: Single;
begin
  tlSetScreen( scrWidth, scrHeight );
  grGlideGetVersion(version);
  (* Initialize Glide *)
  grGlideInit();
  assert( grSstQueryHardware( hwconfig ) );
  grSstSelect( 0 );
  assert( grSstWinOpen( 0,resolution,GR_REFRESH_60Hz,GR_COLORFORMAT_ABGR,GR_ORIGIN_LOWER_LEFT,2, 1 ) );
  tlConSet( 0.0, 0.0, 1.0, 1.0, 60, 30, $ffffff );
  grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE, 	GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_ITERATED, FXFALSE);
  grDepthBufferMode( GR_DEPTHBUFFER_WBUFFER );
  grDepthBufferFunction( GR_CMP_LESS );
  grDepthMask( FXTRUE );

  tlConOutput( 'Press r to change rotation mode'#10#13, [0] );
  tlConOutput( 'Press q or ESC to quit'#10#13, [0] );

  Angle:=0;

  RotationMode:=XAXIS;
  while not fTimeToClose do
  begin
    grBufferClear( $00, 0, GR_WDEPTHVALUE_FARTHEST );

    angle:=angle+1;
    If Angle=360 Then
      Angle:=0;

    Vtx[0].x:=25;
    Vtx[0].y:=25;
    Vtx[0].z:=10;
    Vtx[0].b:=255;
    Vtx[0].g:=0;
    Vtx[0].r:=255;

    Vtx[1].x:=50;
    Vtx[1].y:=25;
    Vtx[1].z:=10;
    Vtx[1].b:=255;

    Vtx[2].x:=50;
    Vtx[2].y:=50;
    Vtx[2].z:=10;
    Vtx[2].b:=255;

    Vtx[3].x:=25;
    Vtx[3].y:=50;
    Vtx[3].z:=10;
    Vtx[3].g:=255;

    Vtx[4].x:=25;
    Vtx[4].y:=25;
    Vtx[4].z:=20;
    Vtx[4].r:=255;

    Vtx[5].x:=50;
    Vtx[5].y:=25;
    Vtx[5].z:=20;
    Vtx[5].b:=255;

    Vtx[6].x:=50;
    Vtx[6].y:=50;
    Vtx[6].z:=20;
    Vtx[6].g:=255;

    Vtx[7].x:=25;
    Vtx[7].y:=50;
    Vtx[7].z:=20;
    Vtx[7].r:=255;

    Case RotationMode Of
      XAXIS: Begin
               tlConOutput( 'Roation aroud X axis'#10, [0]);
               for I:=0 to 7 do begin
                 RotateX(vtx1[i], vtx[i], angle);
                 vtx1[i].x:=300+(vtx1[i].x*distance)/(vtx1[i].z+distance);
                 vtx1[i].y:=200+(vtx1[i].y*distance)/(vtx1[i].z+distance);
                 vtx1[i].oow:=1/(vtx1[i].z+distance);
                 vtx1[i].b:=vtx[i].b;
                 vtx1[i].r:=vtx[i].r;
                 vtx1[i].g:=vtx[i].g;
               end;
             End;
      YAXIS: Begin
               tlConOutput( 'Roation aroud Y axis'#10, [0]);
               for I:=0 to 7 do begin
                 RotateY(vtx1[i], vtx[i], angle);
                 vtx1[i].x:=300+(vtx1[i].x*distance)/(vtx1[i].z+distance);
                 vtx1[i].y:=200+(vtx1[i].y*distance)/(vtx1[i].z+distance);
                 vtx1[i].oow:=1/(vtx1[i].z+distance);
                 vtx1[i].b:=vtx[i].b;
                 vtx1[i].r:=vtx[i].r;
                 vtx1[i].g:=vtx[i].g;
               end;
             End;
      ZAXIS: Begin
               tlConOutput( 'Roation aroud Z axis'#10, [0]);
               for I:=0 to 7 do begin
                 RotateZ(vtx1[i], vtx[i], angle);
                 vtx1[i].x:=300+(vtx1[i].x*distance)/(vtx1[i].z+distance);
                 vtx1[i].y:=200+(vtx1[i].y*distance)/(vtx1[i].z+distance);
                 vtx1[i].oow:=1/(vtx1[i].z+distance);
                 vtx1[i].b:=vtx[i].b;
                 vtx1[i].r:=vtx[i].r;
                 vtx1[i].g:=vtx[i].g;
               end;
             End;
    End;

    Verts[0]:=0;
    Verts[1]:=1;
    Verts[2]:=2;
    Verts[3]:=3;
    grConstantColorValue($FF0000);
    grDrawPolygon(4, Verts, vtx1);

    Verts[0]:=0;
    Verts[1]:=3;
    Verts[2]:=7;
    Verts[3]:=4;
    grConstantColorValue($00FF00);
    grDrawPolygon(4, Verts, vtx1);

    Verts[0]:=7;
    Verts[1]:=6;
    Verts[2]:=5;
    Verts[3]:=4;
    grConstantColorValue($0000FF);
    grDrawPolygon(4, Verts, vtx1);

    Verts[0]:=3;
    Verts[1]:=2;
    Verts[2]:=6;
    Verts[3]:=7;
    grConstantColorValue($FFFF00);
    grDrawPolygon(4, Verts, vtx1);

    Verts[0]:=6;
    Verts[1]:=5;
    Verts[2]:=1;
    Verts[3]:=2;
    grConstantColorValue($00FFFF);
    grDrawPolygon(4, Verts, vtx1);

    Verts[0]:=0;
    Verts[1]:=1;
    Verts[2]:=5;
    Verts[3]:=4;
    grConstantColorValue($FF00FF);
    grDrawPolygon(4, Verts, vtx1);

    tlConRender;
    grBufferSwap( 1 );
    Application.ProcessMessages;
  end;

  grGlideShutdown;
  ReleaseCapture;
  Close;
end;

end.
